c
c  this package contains the miscelaneous and general
c  subroutines and functions:
c              CMZERC,CMZERV,INTERN,LISYM,DVDX,
c              USRAN,VELVERLET,GAUSSJ,GASDEV,WRITQV

c****************************************************************

      subroutine cmzerc(nfrag,ifrag,tmas)

c   calculate centre of mass position
c   and move the positions into the centre of mass frame

      include 'traj.inc'

      dimension ifrag(natom)

      do 2000 j=1,nmol

        ccom(j,1)=0.0d0
        ccom(j,2)=0.0d0
        ccom(j,3)=0.0d0
        do 1400 i=1,nfrag
          ccom(j,1)=ccom(j,1)+amas(ifrag(i))*c(j,ifrag(i),1)
          ccom(j,2)=ccom(j,2)+amas(ifrag(i))*c(j,ifrag(i),2)
          ccom(j,3)=ccom(j,3)+amas(ifrag(i))*c(j,ifrag(i),3)
 1400   continue
        ccom(j,1)=ccom(j,1)/tmas
        ccom(j,2)=ccom(j,2)/tmas
        ccom(j,3)=ccom(j,3)/tmas
 2000 continue
c
      do 2400 j=1,nmol
        do 2300 i=1,nfrag
          c(j,ifrag(i),1)=c(j,ifrag(i),1)-ccom(j,1)
          c(j,ifrag(i),2)=c(j,ifrag(i),2)-ccom(j,2)
          c(j,ifrag(i),3)=c(j,ifrag(i),3)-ccom(j,3)
 2300   continue
        ccom(j,1)=0.0d0
        ccom(j,2)=0.0d0
        ccom(j,3)=0.0d0
 2400   continue
      return
      end

c****************************************************************

      subroutine cmzerv(nfrag,ifrag,tmas)

c   calculate centre of mass velocity
c   and move the velocities into the centre of mass frame

      include 'traj.inc'

      dimension ifrag(natom)

      do 2000 j=1,nmol
        vcom(j,1)=0.0d0
        vcom(j,2)=0.0d0
        vcom(j,3)=0.0d0
        do 1400 i=1,nfrag
          vcom(j,1)=vcom(j,1)+amas(ifrag(i))*v(j,ifrag(i),1)
          vcom(j,2)=vcom(j,2)+amas(ifrag(i))*v(j,ifrag(i),2)
          vcom(j,3)=vcom(j,3)+amas(ifrag(i))*v(j,ifrag(i),3)
 1400   continue
        vcom(j,1)=vcom(j,1)/tmas
        vcom(j,2)=vcom(j,2)/tmas
        vcom(j,3)=vcom(j,3)/tmas
 2000 continue
c
      do 2400 j=1,nmol
        do 2300 i=1,nfrag
          v(j,ifrag(i),1)=v(j,ifrag(i),1)-vcom(j,1)
          v(j,ifrag(i),2)=v(j,ifrag(i),2)-vcom(j,2)
          v(j,ifrag(i),3)=v(j,ifrag(i),3)-vcom(j,3)
 2300   continue
        vcom(j,1)=0.0d0
        vcom(j,2)=0.0d0
        vcom(j,3)=0.0d0
 2400   continue
      return
      end

c****************************************************************

       subroutine intern(j)
 
c   calculates the internal cordinates and their derivatives,
c   for bond lengths, cos(bond angles), and actual torsion angles

      include 'traj.inc'
 
      common /intang1/ rr(nmax,nangle+1),ri(nmax,nbond)
 
c   bond lengths
 
      do 100 i=1,nbond
          r(j,i)=sqrt((c(j,mb(i),1)-c(j,nb(i),1))**2
     .      +(c(j,mb(i),2)-c(j,nb(i),2))**2+(c(j,mb(i),3)-
     .      c(j,nb(i),3))**2)
  100 continue 

c      bond length derivatives
 
c  NB change 16 Aug 99, removed the j index from dr to make the
c  array small enough to compile on a pc
c  for general usage this should be corrected, that is, for example
c  dr(j,i,mb(i),1)...

      do 200 i=1,nbond
          dr(i,mb(i),1)=(c(j,mb(i),1)-c(j,nb(i),1))/r(j,i)
          dr(i,nb(i),1)=-dr(i,mb(i),1)
          dr(i,mb(i),2)=(c(j,mb(i),2)-c(j,nb(i),2))/r(j,i)
          dr(i,nb(i),2)=-dr(i,mb(i),2)
          dr(i,mb(i),3)=(c(j,mb(i),3)-c(j,nb(i),3))/r(j,i)
          dr(i,nb(i),3)=-dr(i,mb(i),3)
  200 continue
 
c      angles
 
      if(nangle.eq.0) go to 1000
 
      do 300 i=1,nangle
          ri(j,lab(i))=1.d0/r(j,lab(i))
          ri(j,mab(i))=1.d0/r(j,mab(i))
          rr(j,i)=ri(j,lab(i))*ri(j,mab(i))

c  calculate cos of the angles:

          ca(j,i)=((c(j,la(i),1)-c(j,ma(i),1))*(c(j,na(i),1)-
     .      c(j,ma(i),1))+
     .      (c(j,la(i),2)-c(j,ma(i),2))*(c(j,na(i),2)-
     .      c(j,ma(i),2))+
     .      (c(j,la(i),3)-c(j,ma(i),3))*(c(j,na(i),3)-
     .      c(j,ma(i),3)))*rr(j,i)

c  calculate sin of angles:

           sa(j,i)=sqrt(1.0d0-ca(j,i)**2)

c  calculate angles:

           a(j,i)=acos(ca(j,i))

  300 continue
 
c      bond angle derivatives
 
c  NB change 16 Aug 99, removed the j index from dr to make the
c  array small enough to compile on a pc
c  for general usage this should be corrected, that is, for example
c  dr(j,i,la(i),1)...

      do 400 i=1,nangle
          da(j,i,la(i),1)=(c(j,na(i),1)-c(j,ma(i),1))*rr(j,i)
     .      -ca(j,i)*dr(lab(i),la(i),1)*ri(j,lab(i))
          da(j,i,na(i),1)=(c(j,la(i),1)-c(j,ma(i),1))*rr(j,i)
     .      -ca(j,i)*dr(mab(i),na(i),1)*ri(j,mab(i))
          da(j,i,ma(i),1)=-(da(j,i,la(i),1)+da(j,i,na(i),1))
          da(j,i,la(i),2)=(c(j,na(i),2)-c(j,ma(i),2))*rr(j,i)
     .      -ca(j,i)*dr(lab(i),la(i),2)*ri(j,lab(i))
          da(j,i,na(i),2)=(c(j,la(i),2)-c(j,ma(i),2))*rr(j,i)
     .      -ca(j,i)*dr(mab(i),na(i),2)*ri(j,mab(i))
          da(j,i,ma(i),2)=-(da(j,i,la(i),2)+da(j,i,na(i),2))
          da(j,i,la(i),3)=(c(j,na(i),3)-c(j,ma(i),3))*rr(j,i)
     .      -ca(j,i)*dr(lab(i),la(i),3)*ri(j,lab(i))
          da(j,i,na(i),3)=(c(j,la(i),3)-c(j,ma(i),3))*rr(j,i)
     .      -ca(j,i)*dr(mab(i),na(i),3)*ri(j,mab(i))
          da(j,i,ma(i),3)=-(da(j,i,la(i),3)+da(j,i,na(i),3))
  400 continue
 
 1000 if(ndihed.eq.0) go to 2000

 2000 continue
 
1     format(6(g12.5))

      return
      end

c*******************************************************************

      subroutine lisym(iwr,csym)
c
c   18/02/89: edited nsym=80 -> 78
c
      character*1 csym
      nsym=78
      write(iwr,50)(csym(1:1),i=1,nsym)
   50 format(1x,78a1)
      return
      end

c*******************************************************************

      subroutine dvdx(j)
c
c   calculates dv/dx from dv/d(internal)*d(internal)/dx
c
      include 'traj.inc'
     
       do 1 i=1,natom                                                    
         dv(j,i,1)=0.0d0
         dv(j,i,2)=0.0d0
         dv(j,i,3)=0.0d0
1      continue
                           
c  NB change 16 Aug 99, removed the j index from dr to make the
c  array small enough to compile on a pc
c  for general usage this should be corrected, that is, for example
c  dr(j,i,mb(i),1)...

       do 2 i=1,nbond
         dv(j,mb(i),1)=dv(j,mb(i),1)+dvr(j,i)*dr(i,mb(i),1)
         dv(j,nb(i),1)=dv(j,nb(i),1)+dvr(j,i)*dr(i,nb(i),1)
         dv(j,mb(i),2)=dv(j,mb(i),2)+dvr(j,i)*dr(i,mb(i),2)
         dv(j,nb(i),2)=dv(j,nb(i),2)+dvr(j,i)*dr(i,nb(i),2)
         dv(j,mb(i),3)=dv(j,mb(i),3)+dvr(j,i)*dr(i,mb(i),3)
         dv(j,nb(i),3)=dv(j,nb(i),3)+dvr(j,i)*dr(i,nb(i),3)
2      continue                                            

      return
      end

c******************************************************

      real*8 function usran(ir)

c
c   this subroutine generates random values between 0.0 and 1.0 using
c   an integer seed
c   it is based on the imsl routine ggubs.
c
c   real*8 version
c
      implicit real*8 (a-h,o-z)
      parameter(da=16807.d0,db=2147483647.d0,dc=2147483648.d0)
      ir=abs(mod(da*ir,db)+0.5d0)
      usran=dfloat(ir)/dc
      return
      end

c******************************************************

      subroutine velverlet(j)

      include 'traj.inc'

      common /vv1/ omasd(natom),dvold(nmax,natom,3)

c   omasd is used in the leap-frog algorithm to update
c   the coordinates and velocities at each time step

      do 800 n=1,natom
        omasd(n)=0.5d0*delta/amas(n)
800   continue

c   start the trajectory integration

c   evaluate the internal coords

      call intern(j)

c   evaluate the internal coordinate derivatives

      call dvdi(j)

c   evaluate the cartesian derivatives from the internal 
c   derivatives

      call dvdx(j)

c   output re t=0 state

        nloop=0
        call outp(j)

      do 1500 nloop=1,nstep

c   update the coordinates
c   skip all molecules whose trajectories have finished 
c  do this by multiplying by ntest
c
c  ntest=1 if a trajectory is still going
c  ntest=0 if a trajectory has triggered an end test or has gone bad

c   the velocity-verlet algorithm :

        do 1250 i=1,natom
           
	   if (ntest(j).eq.0) goto 1150

              c(j,i,1)=c(j,i,1)+ntest(j)*(delta*v(j,i,1)-
     .          delta*omasd(i)*dv(j,i,1))
              c(j,i,2)=c(j,i,2)+ntest(j)*(delta*v(j,i,2)-
     .          delta*omasd(i)*dv(j,i,2))
              c(j,i,3)=c(j,i,3)+ntest(j)*(delta*v(j,i,3)-
     .          delta*omasd(i)*dv(j,i,3))

              dvold(j,i,1)=dv(j,i,1)
              dvold(j,i,2)=dv(j,i,2)
              dvold(j,i,3)=dv(j,i,3)

 1150       continue
 1250   continue

c   evaluate the internal coords

        call intern(j)

c   evaluate the internal coordinate derivatives and
c   potential energy

        call dvdi(j)

c   evaluate the cartesian derivatives from the internal 
c   derivatives

        call dvdx(j)

c   update the velocities
c   skip all molecules whose trajectories have finished 

c   the velocity-verlet algorithm :

        do 1350 i=1,natom

	   if (ntest(j).eq.0) goto 1275

              v(j,i,1)=v(j,i,1)-
     .          ntest(j)*(dvold(j,i,1)+dv(j,i,1))*omasd(i)
              v(j,i,2)=v(j,i,2)-
     .          ntest(j)*(dvold(j,i,2)+dv(j,i,2))*omasd(i)
              v(j,i,3)=v(j,i,3)-
     .          ntest(j)*(dvold(j,i,3)+dv(j,i,3))*omasd(i)

 1275       continue
 1350   continue

c   write out the results where you will

        np=nloop/nprint
        nq=np*nprint

        if(nloop.eq.nq) then
          call outp(j)
	  if(nstop.ge.1)return
        endif

 1500 continue

      return
      end

c****************************************************************

      subroutine gaussj(a,n,np,b,m,mp)
c-------------------------------------------------------------------------------
c
c   subroutine gaussj
c   (numerical recipes, W.T.Vetterling, et.al., p.28)
c
c-------------------------------------------------------------------------------
c   description
c   ===========
c   linear equation solution by Gauss-Jordan elimination, equation (2.1.1).
c   a is an input matrix of n by n elements, stored in an array of physical
c   dimensions np by np.
c   b is an input matrix of n by m containing the m right-hand side vectors,
c   stored in an array of physical dimensions np by mp.
c   on output, a is replaced by its matrix inverse, and b is replaced by the
c   corresponding set of solution vectors.
c-------------------------------------------------------------------------------
c 09/01/88:converted to real*8

        implicit real*8 (a-h,o-z)

c***the integer arrays ipiv, indxr and indxc are used for bookkeeping on the
c***pivoting. nmax should be as large as the largest anticipated value of n.

      parameter (nmax=50)

      dimension a(np,np),ipiv(nmax),indxr(nmax),indxc(nmax),b(np,mp)

      do 11 j=1,n
        ipiv(j)=0
11    continue
c***this is the main loop over the columns to be reduced.
      do 22 i=1,n
        big=0.d0
c***this is the outer loop of the search for a pivot element.
        do 13 j=1,n
          if(ipiv(j).ne.1)then
            do 12 k=1,n
              if (ipiv(k).eq.0) then
                if (abs(a(j,k)).ge.big)then
                  big=abs(a(j,k))
                  irow=j
                  icol=k
                endif
              else if (ipiv(k).gt.1) then
                write(*,*) 'ABORT: singular matrix in routine gaussj'
                stop
              endif
12          continue
          endif
13      continue
        ipiv(icol)=ipiv(icol)+1
c***we now have the pivot element, so we interchange rows, if needed, to put
c***the pivot element on the diagonal. the columns are not physically
c***interchanged, only relabeled: indx(i), the column of the ith pivot element,
c***is the ith column that is reduced, while indxr(i) is the row in which that
c***pivot element was originally located. if indxr(i).ne.indxc(i) there is an
c***implied column interchange. with this form of bookkeeping, the solution b's
c***will end up in the correct order, and the inverse matrix will be scrambled
c***by columns.
        if (irow.ne.icol) then
          do 14 l=1,n
            dum=a(irow,l)
            a(irow,l)=a(icol,l)
            a(icol,l)=dum
14        continue
          do 15 l=1,m
            dum=b(irow,l)
            b(irow,l)=b(icol,l)
            b(icol,l)=dum
15        continue
        endif
c***we are now ready to divide the pivot row by the pivot element located at
c***irow and icol.
        indxr(i)=irow
        indxc(i)=icol
        if (a(icol,icol).eq.0.d0) then
                write(*,*) 'ABORT: singular matrix in routine gaussj'
                stop
        endif
        pivinv=1.d0/a(icol,icol)
        a(icol,icol)=1.d0
        do 16 l=1,n
          a(icol,l)=a(icol,l)*pivinv
16      continue
        do 17 l=1,m
          b(icol,l)=b(icol,l)*pivinv
17      continue
c***next we reduce the rows...except for the pivot one, of course.
        do 21 ll=1,n
          if(ll.ne.icol)then
            dum=a(ll,icol)
            a(ll,icol)=0.d0
            do 18 l=1,n
              a(ll,l)=a(ll,l)-a(icol,l)*dum
18          continue
            do 19 l=1,m
              b(ll,l)=b(ll,l)-b(icol,l)*dum
19          continue
          endif
21      continue
22    continue
c***this is the end of the main loop over columns of the reduction.
c***it only remains to unscramble the solution in view of the column
c***interchanges. we do this by interchanging pairs of columns in the
c***reverse order that the permutation was built up.
      do 24 l=n,1,-1
        if(indxr(l).ne.indxc(l))then
          do 23 k=1,n
            dum=a(k,indxr(l))
            a(k,indxr(l))=a(k,indxc(l))
            a(k,indxc(l))=dum
23        continue
        endif
c***and we are done.
24    continue

      return
      end


c****************************************************************

      real*8 function gasdev(idum)
c-------------------------------------------------------------------------------
c
c   function gasdev
c   (Numerical Recipes, W.T.Vetterling, et.al., p.203)
c
c-------------------------------------------------------------------------------
c   description
c   ===========
c   returns a normally distributed deviate with zero mean and unit variance
c   using usran(idum) in file ranims.f
c   (formerly used ran1(idum) in file ran1ol.f)
c-------------------------------------------------------------------------------
c
c 09/01/88:converted to real*8
c 07/06/89:added save for gset (most computers dont need these save statements)
      implicit real*8 (a-h,o-z)
      save iset, gset
      data iset/0/
      if (iset.eq.0) then
c***we don't have an extra deviate handy,
c***so pick two uniform random numbers in the square extending from -1 to +1
c***in each direction.
1       vv1=2.d0*usran(idum)-1.d0
        vv2=2.d0*usran(idum)-1.d0
        r=vv1**2+vv2**2
        if(r.ge.1.d0)go to 1
        fac=sqrt(-2.d0*log(r)/r)
        gset=vv1*fac
        gasdev=vv2*fac
        iset=1
      else
c***we do have an extra deviate handy,
c***so return it, and unset the flag.
        gasdev=gset
        iset=0
      endif
      return
      end

c****************************************************************

      subroutine writqv
c
c   write positions and velocities to file WQV  
c
      include 'traj.inc'

      open(unit=7,file='WQV',status='unknown')

      write(7,*)'initial positions and velocities for each atom:'

c   write  q's and v's
 
      do 100 j=1,nmol
        write(7,*)' traj # ',j
        do 100 i=1,natom
          write(7,*) (c(j,i,k),k=1,3), (v(j,i,k),k=1,3)
  100   continue
  200 continue

      close (unit=7)

      return
      end

c****************************************************************
