c******************************************************

       subroutine nmode(nfrag,ifrag,tmas,nwhich)

       include 'traj.inc'
       dimension ifrag(natom)

c      open(unit=7,file='FCM',status='unknown')

c  calculates normal modes and their frequencies

       call lisym(11,'-')
       write(11,*) ' *** subroutine nmode:'
       write(11,*)
       if(nwhich.eq.1)then
c        write(11,*)
c        write(11,*)'*** NORMAL MODES OF FRAGMENT A ***'
c        write(11,*)
       else
c        write(11,*)
c        write(11,*)'*** NORMAL MODES OF FRAGMENT B ***'
c        write(11,*)
       endif

       i3n=3*nfrag

c  save position and velocity c,v into arrays cinit,vinit

c  first move the atoms to the equilibrium configuration
c  tc(1,n,ind) read in from CCM
c  and set initial velocities to zero

c  nb we only have to do this once for j=1

       do 10 j=1,nmol
       do 10 n=1,natom
       do 10 ind=1,3
         c(j,n,ind)=tc(1,n,ind)
         v(j,n,ind)=0.0d0
10     continue

c  save initial coordinates to array cinit

      do 300 i=1,natom
        do 250 j=1,nmol
          cinit(j,i,1)=c(j,i,1)
          cinit(j,i,2)=c(j,i,2)
          cinit(j,i,3)=c(j,i,3)
  250 continue
  300 continue

c  transform to centre of mass coordinates:

       call cmzerc(nfrag,ifrag,tmas)

c  calculate internals

       call intern(1)

c  calculate derivatives of the potential wrt internals

       call dvdi(1)

c  calculate derivatives of potential wrt cartesians

       call dvdx(1)

c  store gradient at the equilibrium geometry: g(ij)

       do 20 n=1,nfrag
       do 20 ind=1,3
         ij=ind+(n-1)*3
         g(ij)=dv(1,ifrag(n),ind)
20     continue

c  calculate the force constant matrix:

      call fmtrx(nfrag,ifrag,nwhich)

c  restore original reference position 

      do 400 i=1,natom
        do 350 j=1,nmol
          c(j,i,1)=cinit(j,i,1)
          c(j,i,2)=cinit(j,i,2)
          c(j,i,3)=cinit(j,i,3)
  350 continue
  400 continue

 
      return
      end
 
c*************************************************************
 
       subroutine fmtrx(nfrag,ifrag,nwhich)

c  *****  routine evaluates the force constant           *****
c  *****  matrix by differencing the gradient of the     *****
c  *****  potential energy function.                     *****
 
       include 'traj.inc'

       dimension dist(2),fa(3*natom,3*natom),gz(3*natom)
       dimension ifrag(natom)

       data pt5/0.5d0/
       data two/2.0d0/

       ndim1=3*natom

c  *****  set print file for eigout                  *****

       ip=7

c  displacement interval, hinc
c  no. displacements about cartesian minimum, npts
c  nb npts=2 is a double-sided difference:

       hinc=0.002d0
       npts=2
 
       dist(1)=hinc
       dist(2)=-hinc

c  *****  initialize some arrays                     *****

       i3n=3*nfrag

       do 10 i=1,i3n
         gz(i) = g(i)
10     continue

c      write(7,1000)
c1000  format(10X,5(1H*),' CALCULATION OF FORCE CONSTANT  ',5(1H*))

       do 20 n=1,nfrag
       do 20 ind=1,3
         ij=ind+3*(n-1)
         do 14 j=1,npts
           c(1,ifrag(n),ind)=c(1,ifrag(n),ind)+dist(j)
           call intern(1)
           call dvdi(1)
           call dvdx(1)
           c(1,ifrag(n),ind)=c(1,ifrag(n),ind)-dist(j)
           do 14 n2=1,nfrag
             do 13 ind2=1,3
               kj=ind2+(n2-1)*3
               dg(kj,j)=dv(1,ifrag(n2),ind2)
13           continue
14       continue

c  *****  two point difference formula                    *****

         do 15 k=1,i3n
           fa(k,ij) = (dg(k,1)-dg(k,2))*pt5/(hinc)
15       continue
20     continue

c  zero the eigenvalues, and initially print out the zeroes
c  with the cartesian force constant matrix

       do 21 i=1,i3n
         eig(i)= 0.0d0
21     continue

c      write(7,1002)
c      write(7,1003)

1      format(3g14.7)

1002   format(1H1)
1003   format(15X,' FORCE CONSTANT MATRIX', /)

c      call eigout(fa,i3n,ndim1,ip)

       do 25 i=1,i3n
       do 25 j=1,i
         du = (fa(i,j)+fa(j,i))/two
         dl=(fa(i,j)-fa(j,i))/two
         a1(i,j)=du
         a1(j,i)=dl
25     continue

       do 30 i=1,i3n
         a1(i,i) = fa(i,i)
30     continue

c      write(7,1002)
c      write(7,1004)

1004  format(/,10X,'SYMMETRIZED CARTESIAN FORCE CONSTANT MATRIX'/)
1010  format(10X,'NUMBER OF SYMMETRY OPERATIONS',I3,/)

c      call eigout(a1,i3n,ndim1,ip)

c  *****  convert to mass weighted coordinates and        *****
c  *****  then calculate the normal modes and the         *****
c  *****  spectroscopic frequencies.                      *****

       call fgmtrx(nfrag,ifrag)

c      close(unit=7)

       return
       end
 
c*************************************************************
 
       subroutine fgmtrx(nfrag,ifrag)

c  *****  routine is used to construct an effective       *****
c  *****  wilson -fg- matrix by introducing mass          *****
c  *****  dependence into the potential force constant    *****
c  *****  matrix. the normal modes and the spectro-       *****
c  *****  scopic frequencies are then evaluated.          *****
 
       include 'traj.inc'
       dimension dim(3*natom)
       dimension ifrag(natom)

       data tfact/2.719317909d+05/
       data rho/1.0d-08/

       ndim1=3*natom
 
c  *****  tfact converts the force constants to           *****
c  *****  appropriate units for frequencies in cm-1       *****
c  *****                                                  *****
c  *****          1.6022d-19 * 1.0d20 * 6.02205d25        *****
c  *****  tfact = ---------------------------------       *****
c  *****          4.0d0 * pi**2 * (2.997925d+10)**2       *****

       i3n=3*nfrag
       n = i3n

c  *****  move diagonal of -a1- to -da1- and save           *****

      do 10 i=1,n
        da1(i) = a1(i,i)
10    continue

       do 12 i=1,n
         do 11 j=1,i
           a1(j,i) = a1(i,j)
           a1(i,i) = da1(i)
11       continue
12     continue

c  *****  now diagonalize cartesian force matrix          *****
c  *****  set print file for eigout

       ip=7
       call eign(a1,b1,n,ndim1,rho)

c      write(7,1001)
c      write(7,1002)
1001   format(1H1)
1002   format(/,10X,'EIGENVECTORS OF CARTESIAN FORCE CONSTANT MATRIX'/)

c      call eigout(b1,n,ndim1,ip)

c  *****  create full force matrix for mass weighted      *****
c  *****  transformation                                  *****

       do 20 i=1,n
         do 15 j=1,i
           a1(i,j) = a1(j,i)
15       continue
         a1(i,i) = da1(i)
20     continue

c  *****  construct mass weighted matrix                  *****

c  calculate inverse root of the atomic masses

       k = 0                        
       do 5 i=1,nfrag
       do 5 j=1,3                
         k = k+1             
         dim(k)=1.0d0/sqrt(amas(i))
5     continue

       do 30 i=1,n
       do 30 j=1,n
         a1(i,j) = dim(i)*a1(i,j)*dim(j)
30     continue

c  *****  diagonalize mass weighted matrix                *****

       call eign(a1,b1,n,ndim1,rho)

c  *****  convert frequencies to inverse cm               *****

       do 35 i=1,n
         eig(i)=sqrt(abs(tfact*eig(i)))
35     continue

c  *****  normalize the eigenvectors                      *****

       do 39 i=1,i3n
       do 39 j=1,i3n
         a1(i,j)=b1(i,j)
39     continue

       do 41 i=1,i3n
         dum = 0.0d0
         do 40 j=1,i3n
           dum=dum+a1(i,j)*a1(i,j)
40       continue
         dum=sqrt(dum)
         do 41 j=1,i3n
         a1(i,j)=a1(i,j)/dum
41     continue


c  *****  set phase of eigenvectors                       *****

       do 45 i=1,i3n
         amax=0.0d0
          do 43 j=1,i3n
            if(abs(a1(i,j)).ge.abs(amax)) amax=a1(i,j)
43        continue
          if(amax.lt.0.0d0)then
            do 44 j=1,i3n
              a1(i,j)=-a1(i,j)
44          continue
          endif
45      continue

c  *****  create mass weighted eigen vector               *****

       do 47 i=1,i3n
         do 46 j=1,i3n
           a1(i,j)=dim(j)*a1(i,j)
46       continue
47     continue

c  *****  write eigenvalues and eigenvectors              *****

       ip=11
c      write(11,1001)
       write(11,1003)
1003   format(/,10X,2H**,' NORMAL MODES AND VIBRATIONAL FREQUENCIES,
     &           CM-1 ',2H**)

       call eigout(a1,i3n,ndim1,ip)

       return
       end
 
c*************************************************************
 
       subroutine eigout(a1,n,nd,ip)

c  subroutine outputs an a1(nd,nd) matrix to unit number ip

       implicit double precision (a-h,o-z)

       common/eigvl/eig(150)

       dimension a1(nd,nd)
 
1001   format(//,4X,9(10X,I3))
1002   format(1X,'FREQUENCIES:',F6.1,8F13.1)
1003   format(a4,2X,9F13.7)
1004   format(/)        

       do 1 i=1,n      
       do 1 j=1,i     
         d=a1(i,j)      
         a1(i,j) = a1(j,i)
         a1(j,i)  = d   
1      continue

       k=0          
    2  l=k+1       
       k=k+5      
       if(n.lt.k)k=n 

       write(ip,1001)(i,i=l,k)
       write(ip,1004)
       write(ip,1002)(eig(i),i=l,k)
       write(ip,1004)

       do 3 i=1,n           
        if(i.eq.1)write(ip,1003)'Hx:',(a1(i,j),j=l,k)
        if(i.eq.2)write(ip,1003)'Hy:',(a1(i,j),j=l,k)
        if(i.eq.3)write(ip,1003)'Hz:',(a1(i,j),j=l,k)
        if(i.eq.4)write(ip,1003)'Cx:',(a1(i,j),j=l,k)
        if(i.eq.5)write(ip,1003)'Cy:',(a1(i,j),j=l,k)
        if(i.eq.6)write(ip,1003)'Cz:',(a1(i,j),j=l,k)
        if(i.eq.7)write(ip,1003)'Nx:',(a1(i,j),j=l,k)
        if(i.eq.8)write(ip,1003)'Ny:',(a1(i,j),j=l,k)
        if(i.eq.9)write(ip,1003)'Nz:',(a1(i,j),j=l,k)
3      continue
       if(k.lt.n) go to 2  
       do 4 i=1,n         
       do 4 j=1,i        
         d=a1(i,j)         
         a1(i,j)=a1(j,i)   
         a1(j,i)=d       
4      continue

       return
       end
 
c*************************************************************
 
      subroutine eign(a,vec,nn,nd,rho)                         

c  *****           description                       *****
c  *****   this is a givens-housholder routine       *****
c  *****   receives a matrix-a-of which only lower   *****
c  *****   trangle is used and this is destroyed     *****
c  *****   eigenvalues are returned in algebraic     *****
c  *****   ascending order in array-eig-             *****
c  *****   the eigenvectors are returned in -vec-    *****

c  *****         parameters passed                   *****
c  *****   rho  --  upper limit for off-diagonal     *****
c  *****   nn is the size of the matrix              *****

      implicit double precision (a-h,o-z)

      dimension a(nd,nd),vec(nd,nd)                     

      common/eigvl/eig(150)
      common/eigv2/p(150),q(150),iposv(150),ivpos(150),iord(150)
      common/eigv3/beta(150),gamma(150),w(150),betasq(150)

      rhosq=rho*rho     
      n=nn               

c  n is the actual dimension of the matrix:

      if(n.eq.0) go to 560
      n1=n-1             
      n2=n-2              
      gamma(1)=a(1,1)      

c  case for 2*2 or 1*1 matrices:

      if(n2.eq.0) go to 270 
      if(n2.lt.0)go to 280

       do 260 nr=1,n2 
         b=a(nr+1,nr)    
         s=0.0d0          
         do 130 i=nr,n2    
           s=s+a(i+2,nr)**2   
130      continue

c  *****  prepare for possible bypass of transformation  *****

         a(nr+1,nr)=0.0d0    
         if(s.le.0.0d0) go to 250 
         s=s+b*b           
         sgn=+1.0d0           
         if(b.ge.0.0d0) go to 160
         sgn = -1.0d0         
160      continue
         sqrts=sqrt(s)
         d=sgn/(sqrts+sqrts) 
         temp=sqrt(0.5d0+b*d)
         w(nr)=temp        
         a(nr+1,nr)=temp    
         d=d/temp            
         b=-sgn*sqrts         

c  *****  d is factor of proportionality.            *****   
c  *****  compute and save w vector                  *****   

         do 170 i=nr,n2        
           temp=d*a(i+2,nr)       
           w(i+1)=temp             
           a(i+2,nr)=temp           
170      continue

c  *****  premultiply vector-w-by matrix -a- to obtain *****
c  *****  -p- vector.  simultaneously accumulate dot   *****
c  *****  product wp,(the scalar k).                   *****

         wtaw = 0.0d0              
         do 220 i=nr,n1             
           sum = 0.0d0                 
           do 180 j=nr,i                
             sum=sum+a(i+1,j+1)*w(j)       
180        continue
           i1=i+1                         
           if((n1-i1).lt.0) go to 210      
           do 200 j=i1,n1                   
             sum=sum+a(j+1,i+1)*w(j)           
200        continue
210        continue
           p(i)=sum                           
           wtaw=wtaw+sum*w(i)                  
220      continue

c  *****  p vector and scalar k now stored. next     *****
c  *****  compute -q- vector                         *****

         do 230 i=nr,n1                       
           q(i)=p(i)-wtaw*w(i)                   
230      continue

c  *****  now form pap matrix, required part         *****

         do 240 j=nr,n1                         
           qj=q(j)                                 
           wj=w(j)                                  
           do 240 i=j,n1                             
             a(i+1,j+1)=a(i+1,j+1)-2.0d0*(w(i)*qj+wj*q(i)) 
240      continue

250      continue

         beta(nr)=b             
         betasq(nr)=b*b          
         gamma(nr+1)=a(nr+1,nr+1) 
260    continue

270    continue
       b=a(n,n-1)     
       beta(n-1)=b     
       betasq(n-1)=b*b  
       gamma(n)=a(n,n)
280    continue
       betasq(n)=0.0d0

c  *****  adjoin an identity matrix to be            *****
c  *****  postmultiplied by rotations                *****

       do 300 i=1,n 
         do 290 j=1,n  
           vec(i,j)=0.0d0 
290      continue
         vec(i,i)=1.0d0  
300    continue

       m=n              
       sum=0.0d0         
       npas=1             
       go to 400           
310    continue
       sum=sum+shift        
       cosa=1.0d0
       g=gamma(1)-shift       
       pp=g                    
       ppbs=pp*pp+betasq(1)     
       ppbr=sqrt(ppbs)
       do 370 j=1,m              
         cosap=cosa                 
         if(ppbs.ne.0.0d0) go to 320     
         sina = 0.0d0                 
         sina2=0.0d0                   
         cosa=1.0d0                     
         go to 350                       
320      continue
         sina=beta(j)/ppbr                
         sina2=betasq(j)/ppbs              
         cosa=pp/ppbr                       

c  *****  postmultiply identity by p-transpose       *****

         nt=j+npas                           
         if(nt.le.n) go to 330                
         nt = n                                
330      continue
         do 340 i=1,nt                          
           temp=cosa*vec(j,i)+sina*vec(j+1,i)      
           vec(j+1,i)=-sina*vec(j,i)+cosa*vec(j+1,i)
           vec(j,i)=temp            
340      continue
350      continue
         dia=gamma(j+1)-shift      
         u=sina2*(g+dia)            
         gamma(j)=g+u                
         g=dia-u                      
         pp=dia*cosa-sina*cosap*beta(j)
         if(j.ne.m) go to 360    
         beta(j)=sina*pp          
         betasq(j)=sina2*pp*pp     
         go to 380                  
360      continue
         ppbs=pp*pp+betasq(j+1)      
         ppbr=sqrt(ppbs)
         beta(j)=sina*ppbr            
         betasq(j)=sina2*ppbs          
370    continue

380    continue
       gamma(m+1)=g

c  *****  test for convergence of last diagonal element  *****

       npas=npas+1                     
       if(betasq(m).gt.rhosq) go to 410 
390    continue
       eig(m+1)=gamma(m+1)+sum    
400    continue
       beta(m)=0.0d0               
       betasq(m)=0.0d0              
       m=m-1                         
       if(m.eq.0) go to 430           
       if(betasq(m).le.rhosq) go to 390

c  *****  take root of corner 2 by 2 nearest to      *****
c  *****  lower diagonal in value as estimate of     *****
c  *****  eigenvalue to use for shift                *****

410    continue
       a2=gamma(m+1)        
       r2=0.5d0*a2
       r1=0.5d0*gamma(m)
       r12=r1+r2             
       dif=r1-r2              
       temp=sqrt(dif*dif+betasq(m))
       r1=r12+temp            
       r2=r12-temp             
       dif=abs(a2-r1)-abs(a2-r2)
       if(dif.lt.0.0d0) go to 420 
       shift=r2             
       go to 310             

420    continue
       shift=r1               
       go to 310               

430    continue
       eig(1)=gamma(1)+sum      

c  *****  initialize auxiliary tables required for   *****
c  *****  rearanging the vectors                     *****

       do 440 j=1,n              
         iposv(j)=j                 
         ivpos(j)=j                  
         iord(j) = j                  
440    continue

c  ***** use a transpositon sort to order the eigenvalues  *****

       m=n                           
       go to 470                      

450    continue
       do 460 j=1,m                    
         if(eig(j).le.eig(j+1)) go to 460 
         temp=eig(j)     
         eig(j)=eig(j+1)  
         eig(j+1)=temp     
         itemp=iord(j)      
         iord(j)=iord(j+1)
         iord(j+1)=itemp   
460    continue           

470    continue
       m=m-1               
       if(m.ne.0) go to 450 
       if(n1.eq.0) go to 500 
       do 490 l=1,n1     
         nv=iord(l)         
         np=iposv(nv)        
         if(np.eq.l) go to 490
         lv=ivpos(l)    
         ivpos(np)=lv    
         iposv(lv)=np     
         do 480 i=1,n      
           temp=vec(l,i)      
           vec(l,i)=vec(np,i)  
           vec(np,i) = temp     
480      continue

490    continue

500    continue

c  *****  back transform the vectors of the triple   *****
c  *****  diagonal matrix                            *****

       do 550 nrr=1,n          
         k=n1                     
510      continue
         k=k-1                     
         if(k.le.0) go to 540       
         sum = 0.0d0                 
         do 520 i=k,n1    
           sum=sum+vec(nrr,i+1)*a(i+1,k)
520      continue
         sum=sum+sum     
         do 530 i=k,n1    
           vec(nrr,i+1)=vec(nrr,i+1)-sum*a(i+1,k)
530      continue
         go to 510
540      continue
550    continue

560    continue

       return
       end
 
c*************************************************************

